/*
 * (c) Avelino Herrera Morales
 *
 * Ejemplo de aplicacin de la ecuacin en diferencias y[n] = 2*x[n] + x[n-1] - y[n-2].
 * En la salida del programa se puede observar como la seal resultante oscila.
 *
	This software is free software; you can redistribute it and/or modify
	it under the terms of the GNU  General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
																																																																																																							 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU  General Public License for more details.
																																																																																																							 
	You should have received a copy of the GNU  General Public
	License along with this software; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
	02111-1307, USA.
 */
#include <stdio.h>
#include <stdlib.h>

#define  TAM  500   /* generamos 500 muestras en total */

/* entrada en los instantes de tiempo n y n-1 */
/* para excitar el filtro la primera muestra la ponemos a 1.0 */
float input_n = 1.0, input_n_1 = 0;
/* salida en los instantes de tiempo n, n-1 y n-2 */
float output_n = 0, output_n_1 = 0, output_n_2 = 0;

int main(void) {
	int i;

	for (i = 0; i < TAM; i++) {
		/* aplicamos la ecuacin en diferencias */
		output_n = 2 * input_n + input_n_1 - output_n_2;
		/* mostramos la salida de forma numrica */
		/* podremos ver cmo la onda de salida tiene una perioricidad de 4
		   muestras, es decir, una frecuencia de PI/2, la mitad de la
		   frecuencia mxima (la frecuencia mxima (PI) tiene una perioricidad
		   de 2 muestras)
		   si emitimos esta seal a travs de la tarjeta de sonido con una
		   frecuencia de muestreo de 44.1 KHz, oiremos un tono de 11050 Hz */
		printf("%.5f\n", output_n);
		/* realizamos los desplazamientos de las muestras */
		output_n_2 = output_n_1;
		output_n_1 = output_n;
		input_n_1 = input_n;
		input_n = 0;  /* anulamos las siguientes muestras de entrada */
		}
	return 0;
	}
