/*
 * (c) Avelino Herrera Morales
 *
 * Sntesis mediante ondas de terreno.
 *
	This software is free software; you can redistribute it and/or modify
	it under the terms of the GNU  General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
																																																																																																							 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU  General Public License for more details.
																																																																																																							 
	You should have received a copy of the GNU  General Public
	License along with this software; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
	02111-1307, USA.
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include "audio.h"


#define  F_XY     220    /* un LA en la 3 octava del piano */
#define  F_MUEST  44100  /* frecuencia de muetreo: 44.1 KHz */
#define  TIEMPO   2      /* segundos de reproduccin */
#define  ATAQUE   0.04
#define  CAIDA    0.9

#define  MUESTRAS_TOTALES  (TIEMPO * F_MUEST)
#define  MUESTRAS_ATAQUE   ((int)(ATAQUE * F_MUEST))
#define  MUESTRAS_CAIDA    ((int)(CAIDA * F_MUEST))

signed short int salida[MUESTRAS_TOTALES];

int env_t = 0;

float envolvente(void) {
	float v;

	v = 0;
	if (env_t <= MUESTRAS_ATAQUE) {
		v = (float)env_t / MUESTRAS_ATAQUE;
		}
	else if ((env_t > MUESTRAS_ATAQUE) &&
	         ((env_t - MUESTRAS_ATAQUE) <= MUESTRAS_CAIDA)) {
		v = 1.0 - ((float)(env_t - MUESTRAS_ATAQUE) / MUESTRAS_CAIDA);
		}
	env_t++;
	return v;
	}

float g1(float x, float y) {
	return (sqrt(x + 1) * y * x * (x - 4) * (y + 2));
	}

float g2(float x, float y) {
	return ((x - y) * (x - 1) * (x + 1) * (y - 1) * (y + 1));
	}

int main(void) {
	int i;
	int fd;
	float v, x, y, env;

	fd = audio_open(0);
	for (i = 0; i < MUESTRAS_TOTALES; i++) {
		env = envolvente();
		x = env * cos(2 * M_PI * ((float)i / F_MUEST) * F_XY);
		y = env * sin(2 * M_PI * ((float)i / F_MUEST) * F_XY);
		v = g2(x, y);
		v = (v > 1.0) ? 1.0 : ((v < -1.0) ? -1.0 : v);
		salida[i] = (int) rint(v * 32767);
		}
	write(fd, salida, MUESTRAS_TOTALES * sizeof(signed short int));
	return 0;
	}
