/*
	Raw & non block keyboard access

	(c) Avelino Herrera Morales

	This software is free software; you can redistribute it and/or modify
	it under the terms of the GNU  General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
																																																																																																							 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU  General Public License for more details.
																																																																																																							 
	You should have received a copy of the GNU  General Public
	License along with this software; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
	02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
#include <asm/ioctls.h>
#include "raw_keyboard.h"


void raw_keyboard_done(struct termios *old_state) {
	tcsetattr(0, TCSANOW, old_state);
	fcntl(0, F_SETFL, 0);
	return;
	}

void raw_keyboard_init(struct termios *old_state) {
	struct termios t;

	tcgetattr(0, old_state);
	t = *old_state;
	t.c_iflag &= ~(IGNBRK | BRKINT | PARMRK | ISTRIP |
	               INLCR | IGNCR | ICRNL | IXON);
	/* t.c_oflag &= ~OPOST; */
	t.c_lflag &= ~(ECHO | ECHONL | ICANON | ISIG | IEXTEN);
	t.c_cflag &= ~(CSIZE | PARENB);
	t.c_cflag |= CS8;
	tcsetattr(0, TCSANOW, &t);
	fcntl(0, F_SETFL, O_NONBLOCK);
	return;
	}

long int raw_keyboard_read(void) {
	int n;
	long int data;

	ioctl(0, TIOCINQ, &n);
	if (n > 0) {
		data = 0;
		read(0, &data, n);
		}
	 else
		data = -1;
	return data;
	}

