
/*
	VT100 terminal functions

	(c) Avelino Herrera Morales

	This software is free software; you can redistribute it and/or modify
	it under the terms of the GNU  General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
																																																																																																							 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU  General Public License for more details.
																																																																																																							 
	You should have received a copy of the GNU  General Public
	License along with this software; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
	02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <fcntl.h>
#include <unistd.h>
#include "vt.h"


void vt_gotoxy(int x, int y) {
	printf("\e[%d;%dH", y, x);
	fflush(stdout);
	return;
	}

void vt_getxy(int *x, int *y) {
	struct termios t, old;
	int old_flags;
	char data[20];
	int i;

	tcgetattr(0, &old);
	t = old;
	cfmakeraw(&t);
	old_flags = fcntl(0, F_GETFL);
	fcntl(0, F_SETFL, O_NONBLOCK);

	printf("\e[6n");
	fflush(stdout);
	while (read(0, data, 1) != 1)
		;
	i = 1;
	while (read(0, &data[i], 1) == 1)
		i++;
	data[i] = 0;
	sscanf(data, "\e[%d;%dR", y, x);

	fcntl(0, F_SETFL, old_flags);
	tcsetattr(0, TCSANOW, &old);
	return;
	}

void vt_getsize(int *maxx, int *maxy) {
	int x, y;

	vt_getxy(&x, &y);
	vt_gotoxy(32000, 32000);
	vt_getxy(maxx, maxy);
	vt_gotoxy(x, y);
	return;
	}

void vt_clrscr(void) {
	printf("\e[2J");
	fflush(stdout);
	return;
	}

void vt_clreol(void) {
	printf("\e[K");
	fflush(stdout);
	return;
	}

void vt_attrib(int attrib) {
	printf("\e[%dm", attrib);
	fflush(stdout);
	return;
	}

void vt_save_cursor_attrib(void) {
	printf("\e7");
	fflush(stdout);
	return;
	}

void vt_restore_cursor_attrib(void) {
	printf("\e8");
	fflush(stdout);
	return;
	}

void vt_reset(void) {
	printf("\ec");
	fflush(stdout);
	return;
	}

void vt_set_scrollable_window(int start_line, int end_line) {
	printf("\e[%d;%dr", start_line, end_line);
	fflush(stdout);
	return;
	}

void vt_unset_scrollable_window(void) {
	printf("\e[r");
	fflush(stdout);
	return;
	}

